/**
******************************************************************************
* @file    uart_usb.h
* @author  IC Applications Department
* @version  V0.8
* @date  2019_08_02
* @brief   This file contains all the uart_usb inc file for the library.
******************************************************************************
* @copy
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
* TIME. AS A RESULT, HOLOCENE SHALL NOT BE HELD LIABLE FOR ANY
* DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
* FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
* CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*
* <h2><center>&copy; COPYRIGHT 2016 HOLOCENE</center></h2>
*/
#ifndef __UART_USB_H
#define __UART_USB_H
#include "sys.h"
#include "stdio.h"
//////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////

#define UART_REC_LEN  			200  	//ֽ 200
#define EN_UART1_RX 			1		//ʹܣ1/ֹ01


/** @defgroup UART_Interrupt_definition
  * @{
  */


#define UART_IT_ERR            ((uint16_t)0x0020)
#define UART_IT_PE             ((uint16_t)0x0010)
#define UART_OVER_ERR          ((uint16_t)0x0008)
#define UART_TIMEOUT_ERR       ((uint16_t)0x0004)
#define UART_IT_RXIEN          ((uint16_t)0x0002)
#define UART_IT_TXIEN          ((uint16_t)0x0001)




/** @defgroup UART_Flags
  * @{
  */


#define UART_FLAG_TXEMPTY                   ((uint16_t)0x0008)
#define UART_FLAG_TXFULL                    ((uint16_t)0x0004)
#define UART_FLAG_RXAVL                     ((uint16_t)0x0002)
#define UART_FLAG_TXEPT                     ((uint16_t)0x0001)


extern u8  UART_RX_BUF[UART_REC_LEN]; //ջ,UART_REC_LENֽ.ĩֽΪз
extern u16 UART_RX_STA;         		//״̬
//봮жϽգ벻Ҫעº궨
void UartInit(UART_TypeDef* UARTx,int BaudRate);
void uart_sendArray(unsigned char *dataBuf, unsigned int len);

#endif

/**
* @}
*/

/**
* @}
*/

/**
* @}
*/

/*-------------------------(C) COPYRIGHT 2016 HOLOCENE ----------------------*/


